# Shudder

Tweak this example to fit your situation.

Given this directory structure:

    javascript
    |- run_tests.sh
    |- test/           # containing .js Shudder test files
    |- lib/            # containing the JavaScript library under test
    |- vendor/
       |- shudder/     # this Shudder project

Use this for `run_tests.sh`:

    #!/bin/bash
		TESTS=$PWD/test ./vendor/shudder/run_tests.js

This uses Shudder's `run_tests.js` to run your tests in the `test` directory.  It will find the rest of the Shudder library for itself.

Your tests in the `test` folder should require Shudder like so:

    var shudder = require('../vendor/shudder/lib/shudder.js');

Tweak paths as desired, just remember that paths in a `require` are relative to the *source file* when they're called, not the directory where you execute `run_tests.sh`.  (This is why the bash script above uses `$PWD/test` to point to the directory of tests.)


## Port to Node.js

Shudder plays quite well with Node.js and its module system, except for a Prototype dependency due to Ersatz.  So that Ersatz plays well, it has been copied locally into `vendor/ersatz-for-node`.  (The Ersatz submodule in `vendor` is not used on this branch.)

See `run_tests.js` and `test_case_test.js` to see how to use Shudder with Node.js.


## Wishlist

Better stack traces.

* Stack traces are useless when an Ersatz expectation fails.  As a post-should hook, this might be hard or even impossible to fix.
* Show name and/or line number of failing "should"?

Error/failure summary.

* Errors and failures which do no halt execution are reported but can be easily lost off the top of the screen.
* Need an error & failure summary at the end.
