#!/usr/bin/env node

var shudder = require("./lib/shudder"),
    fs = require('fs');
var TestCase = shudder.TestCase;

(function() {
  var findTests = function(testDir) {
    var testFiles = [];
    var foundFiles = fs.readdirSync(testDir);
    for (var i = 0; i < foundFiles.length; i++) {
      var filepath = testDir + "/" + foundFiles[i];
      if (fs.lstatSync(filepath).isDirectory()) {
        testFiles = testFiles.concat(findTests(filepath))
      } else if ((new RegExp('.*_test\.js$')).test(filepath)) {
        testFiles.push(filepath);
      }
    }
    return testFiles;
  };

  var loadTests = function(tests) {
    for (var i = 0; i < tests.length; i++) { 
      require(tests[i]); 
    }
  };
  
  var runTests = function() {
    var runner = new TestCase.Runner(); 
    runner.runTests(TestCase.cases);
  };
  
  loadTests(findTests(process.env['TESTS'] || ("./test")));
  runTests();
})();